!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine check_min(r, flag)
      use blocks
      use OptF
      implicit none
      real*8   , intent(in)  :: r(0:Nm1)
      logical*4, intent(out) :: flag

      integer*4 i
      real*8 r1,r2,r3,sum,y(0:Nm1)
      complex*16 z(L+1:M)

      INTERFACE

         pure subroutine DFT_dir_r(o,u,r,y)
         use blocks
         integer*4 , intent(in)  :: o, u
         real*8    , intent(in)  :: r(0:Nm1)
         complex*16, intent(out) :: y(o:u)
         end subroutine DFT_dir_r

      END INTERFACE

      flag = .true.

      do 1, i=0,Nm1
      r1   = r(i)
      r2   = r1 - ru
      r3   = r1 + r2
      y(i) = r1*r2*r3
 1    continue
      
      call DFT_dir_r(L+1,M,y,z)

      sum = rz
      do 2, i=L+1,M
         sum = sum + cdabs(z(i))**2
 2    continue
      sum = dsqrt(sum /dfloat(M-L))
      
      if(sum .lt. rmcerr) flag=.false.

      return
      end
