!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine random_dir(rn1,rn2,rn3,rn4,t)
      use blocks
      implicit none
      real*8,  intent(in)  :: rn1(Lp1:M)
      real*8,  intent(in)  :: rn2(Lp1:M)
      real*8,  intent(in)  :: rn3(Lp1:M)
      real*8,  intent(in)  :: rn4(Lp1:M)
      real*8,  intent(out) :: t(0:Nm1)

      real*8, dimension(0:Nm1) :: cp, sp
      real*8    c1, c2
      integer*4 i
      real*8 arr1(Lp1:M), arr2(Lp1:M), sum

      INTERFACE

         pure subroutine make_p(i,cp,sp)
         use blocks
         use Fourier
         integer*4, intent(in)  :: i
         real*8,    intent(out) :: cp(0:Nm1), sp(0:Nm1)
         end subroutine make_p

      END INTERFACE

      sum = rz
      do 2,i=Lp1,M
      sum = sum + rn1(i) + rn2(i)
      arr1(i) = rn1(i)
      arr2(i) = rn2(i)
 2    continue
      arr1 = arr1/sum
      arr2 = arr2/sum

      t = rz
      do 1, i=Lp1,M
      c1 = dsqrt(arr1(i))
      c2 = dsqrt(arr2(i))
      if(rn3(i) .lt. half) c1 = -c1
      if(rn4(i) .lt. half) c2 = -c2
      call make_p(i,cp,sp)
      t = t + c1*cp + c2*sp
 1    continue
      t = t / const

      return
      end
