!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine tune_r_1(r)
      use blocks
      implicit none
      real*8, intent(inout) :: r(0:Nm1)

      real*8, dimension(0:Nm1) :: cp, sp
      real*8    alpha
      integer*4 i, info
      logical*4 flag

      INTERFACE

         pure subroutine make_p(i,cp,sp)
         use blocks
         integer*4, intent(in)  :: i
         real*8,    intent(out) :: cp(0:Nm1), sp(0:Nm1)
         end subroutine make_p

         pure subroutine make_alpha(r,p,alpha,flag,info)
         use blocks
         real*8,    intent(in)  :: r(0:Nm1), p(0:Nm1)
         real*8,    intent(out) :: alpha
         logical*4, intent(out) :: flag
         integer*4, intent(out) :: info
         end subroutine make_alpha
      
      END INTERFACE


      do 1, i=Lp1,M

      call make_p(i,cp,sp)

      call make_alpha(r,cp,alpha,flag,info)
      if(flag) r = r + alpha*cp

      call make_alpha(r,sp,alpha,flag,info)
      if(flag) r = r + alpha*sp

 1    continue

      return
      end
