      module blocks
      implicit none

      character*16                          :: Method

      complex*16, parameter                 :: cz=(0.0d0,0.0d0)
      complex*16, parameter                 :: cu=(0.0d0,1.0d0)
      complex*16, allocatable, dimension(:) :: phi

      real*8, parameter :: rz    = 0.0d0
      real*8, parameter :: ru    = 1.0d0
      real*8, parameter :: two   = 2.0d0
      real*8, parameter :: half  = 0.5d0
      real*8, parameter :: small = 1.0d-8
      real*8, parameter :: tiny  = 1.0d-12
      real*8, parameter :: gig   = 1.0d9
      real*8, parameter :: pi    = 4.0d0*datan(1.0d0)

      real*8 del, eps, const

      integer*4 N, Nm1, N1, N0, L, Lp1, M, Mp1, Mp2, LN
      integer*4 depth_max

      logical*4, parameter :: CheckCubeRoots = .false.

      save
      end
